﻿using System;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Services.Hive.Common.DataTransfer;

namespace HeuristicLab.Clients.Hive {
  public class StateLogItem : Item {
    public DateTime DateTime { get; set; }
    public Guid? UserId { get; set; }
    public Guid? SlaveId { get; set; }
    public string Exception { get; set; }
    public JobState State { get; set; }
    public Guid JobId { get; set; }

    public StateLogItem() { }
    public StateLogItem(StateLog stateLog) {
      this.DateTime = stateLog.DateTime;
      this.UserId = stateLog.UserId;
      this.SlaveId = stateLog.SlaveId;
      this.Exception = stateLog.Exception;
      this.State = stateLog.State;
      this.JobId = stateLog.JobId;
    }

    protected StateLogItem(StateLogItem original, Cloner cloner)
      : base(original, cloner) {
      this.DateTime = original.DateTime;
      this.UserId = original.UserId;
      this.SlaveId = original.SlaveId;
      this.Exception = original.Exception;
      this.State = original.State;
      this.JobId = original.JobId;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new StateLogItem(this, cloner);
    }

    public override string ToString() {
      return State.ToString();
    }
  }
}
